###########################################################################
#           CrackerOp.tcl v1.2.8 by strikelight ([sL]@EfNet)              # 
###########################################################################
#
# ABOUT
# =====
# CrackerOp.tcl is based on mikee's cracker-ops from his modified
# eggdrop1.1.5+rufus1.4.9+mikee0.5 source code (www.mikee.org), and a
# large portion of this script is pretty much a direct translation from
# the C code to TCL.  Crackers (or cookies) are used to detect when a 
# user/bot's TCPIP stream has been hijacked by a hacker, meaning that
# they can control what is sent to the server using your connection,
# such as ill-gained opping.  This script will secure the modes your bots
# send to a server by tagging on Crackers to legitimate op modes it issues,
# and will also verify Crackers used by other bots using this script in your
# channels. It will look something like such:
# 
# *** bot1 sets mode: +o-b bot2 CBClm02V.!WA/@Qqunb04xiqrmFKeajlfIK7r00fwkm/sEzyTl
#
# It's not pretty, but it does the trick, as the crackers used in this
# script are truly dynamic and botnet independant.
#
###########################################################################
#
# REQUIREMENTS
# ============
# - Eggdrop1.1.5 Compiled with RAW binding enabled
#   (#define RAW_BINDS in src/eggdrop.h and recompile eggdrop)
# - Should work with Eggdrop1.3.x and higher without any modifications
#
# (Tested only on 1.1.5 so far)
###########################################################################
#
# USAGE
# =====
# - Place crackerop.tcl in your scripts directory and place the line
#   "source scripts/crackerop.tcl" in your eggdrop configuration file
#   just above where the rest of your scripts are loaded (near the bottom
#   of the eggdrop configuration file)
# - Edit the configuration section below to your liking
# - For eggdrop1.1.5-eggdrop1.4.x users, chattr all users/bots you want
#   to be using crackers with their opping with the "z" global flag or the
#   channel "Z" flag to be more channel specific.
#   (!!!INCLUDING the bot the script is running on)
# - For eggdrop1.5.x-eggdrop1.6.x users, chattr all users/bots you want
#   to be using crackers with their opping with the "Z" global flag or the
#   channel "Z" flag to be more channel specific.
#   (!!!INCLUDING the bot the script is running on)
# - For eggdrop1.1.5-eggdrop1.4.x users, to mark a channel as a Cracker'ed
#   channel, you must do in the partyline '.+crackers <channel>' and to
#   unmark a channel as being Cracker'ed you would do '.-crackers <channel>'
#   To list Cracker channels, the command is '.crackers'
# - For eggdrop1.5.x-eggdrop1.6.x users, to mark a channel as a Cracker'ed
#   channel, you must simply do in the partyline '.chanset <channel> +crackers'
#   and similarly, to remove you would do '.chanset <channel> -crackers'
# - When first installing this script, do '.genkeycode' in your bot's
#   partyline, and follow the instructions.
#   ('.genkeycode <key1> <key2>')
#
# NOTE: THIS IS -NOT- A REPLACEMENT TCL FOR YOUR REGULAR GETOPS/GAINOPS
#       TCL SCRIPTS, (OR WHATEVER ELSE YOU USE FOR YOUR BOTNET TO GET OPS)
#       YOU MUST KEEP THEM IN YOUR EGGDROP CONFIGURATION FILE
#
###########################################################################
#
# HISTORY
# =======
# -> 1.0.0 - 1.2.8 (August 8 - August 10)
#  - initial release
#
###########################################################################
#
# BUGS/TODO
# =========
# -* Not setting its own opkey when getting opped? (yew!striker!#mame)
# -* Shouldn't store keys for -z/-Z users
# -* -crackers/-mcrackers should clear stored array values for the channel
# -* crackerunsetBindPart (-chan.. "invalid channel")
#
###########################################################################

###### CONFIGURATION #######

# Kick message to issue when a bad cracker is detected
set text-badcracker "bad cracker"

# sometimes an op will get netsplit, and perform several valid +o modes.
# CRACKER_MISS_MAX defines the number of modes we will allow ourselves
# to 'miss' to see if this is the case.  Careful, make this too high
# and the bot will waste alot of time checking keys.  Try to see what
# will work best for your IRC network.  Remember also that eggdrop will
# eventually mark a netsplit member as 'lost'.  So you only need to account
# for a split that can last at most several minutes.
set CRACKER_MISS_MAX 10

# CRACKER_SEQ_INCR defines how much the dynamic opkey should be expected
# to be incremented after each op
set CRACKER_SEQ_INCR 1

# Allow usage of .op dcc command by users? (0 = no, 1 = yes)
set cracker_use_dcc_op 1

# Allow usage of /msg <bot> op <pass> by users? (0 = no, 1 = yes)
set cracker_use_msg_op 0

### GENKEY ###
#set defdynkey "012345"
set defdynkey "[decrypt abc123 W1Yg2/PuapP/]"

### END OF CONFIGURATION ###

set eggversion [string trimleft [lindex $version 1] 0]

set CRACKDEBUG 1
set CrackerVers "010208"

if {$eggversion < 1050000} {
  proc newflag {flag} {
    foreach i {1 2 3 4 5 6 7 8 9 0} {
      global flag$i
      if {[eval set flag$i] == $i} {
        set flag$i $flag
        if {[eval set flag$i] != $flag} { return 0 }
        return 1
      }
    }
    return 0
  }

  proc newchanflag {flag} {
    foreach i {1 2 3 4 5 6 7 8 9 0} {
      global chanflag$i
      if {[eval set chanflag$i] == $i} {
        set chanflag$i $flag
        if {[eval set chanflag$i] != $flag} { return 0 }
        return 1
      }
    }
    return 0
  }
  newflag z
  newchanflag Z
}

proc crackmatchattr {hand args} {
  global eggversion
  if {[lindex $args 0] == ""} { return 1 }
  set flags [lindex $args 0]
  set flag1 [lindex [split $flags |&] 0]
  set flag2 [lindex [split $flags |&] 1]
  set chan [lindex $args 1]
  if {[string match *|* $flags]} {
    if {$eggversion < 1030000} {
      if {[CRACKDEBUG]} {
        putlog "DEBUG: matchattr: [expr ([matchattr $hand $flag1]) || ([matchchanattr $hand $flag2 $chan])]"
      }
      return [expr ([matchattr $hand $flag1]) || ([matchchanattr $hand $flag2 $chan])]
    } else {
      return [matchattr $hand $flags $chan]
    }
  } elseif {[string match *&* $flags]} {
    if {$eggversion < 1030000} {
      return [expr ([matchattr $hand $flag1]) && ([matchchanattr $hand $flag2 $chan])]
    } else {
      return [matchattr $hand $flags $chan]
    }
  } else {
   return [matchattr $hand $flags]
  }
}

proc CRACKDEBUG {} {
  global CRACKDEBUG
  return $CRACKDEBUG
}

if {[info commands DYNAMIC_CRACKER_STRING] == ""} {
  set tempprocvar "proc DYNAMIC_CRACKER_STRING \{\} \{ return $defdynkey \}"
  eval $tempprocvar
  catch {unset tempprocvar}
}
catch {unset defdynkey}

proc crange {xr xr1 xr2} {return [join [lrange [split $xr] $xr1 $xr2]]}
proc cindex {xr xr1} {return [join [lrange [split $xr] $xr1 $xr1]]}

proc lremove {list data} {
 set new_list ""
 foreach item $data {
  while {[lsearch -exact $list $item] > "-1"} {
   set list [lreplace $list [lsearch -exact $list $item] [lsearch -exact $list $item]]
  }
 } ; return $list
}


proc CHAN_CRACKERS {chan} {
  global eggversion
  set chan [string tolower $chan]
  if {$eggversion < 1050000} {
    global crackerchans
    if {[lsearch -exact $crackerchans $chan] != -1} {
      return 1
    }
    return 0
   } else {
    if {[lsearch -exact [channel info $chan] +crackers] != -1} {
      return 1
    }
    return 0
  }
}

proc create_opkey {size} {
  set capitals "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
  set littles "abcdefghijklmnopqrstuvwxyz"
  set numbers "0123456789"

  set nkey ""

  for {set i 0} {$i < $size} {incr i} {
    set j [rand 3]
    if {$j == 0} {
      set r "[string index $littles [rand 26]]"
    } elseif {$j == 1} {
      set r "[string index $numbers [rand 10]]"
    } elseif {$j == 2} {
      set r "[string index $capitals [rand 26]]"
    }
    append nkey $r
  }
  return $nkey
}

proc do_queued_ops {chan} {
  global opqueues botnick
  set chan [string tolower $chan]
  if {![info exists opqueues($chan)] || ($opqueues($chan) == "")} {
    return
  }
  if {![validchan $chan] || ![isop $botnick $chan]} {
    catch {unset opqueues($chan)}
    return
  }
  set who [lindex $opqueues($chan) 0]
  if {![onchan $who $chan]} {
    set opqueues($chan) [lremove $opqueues($chan) [split $who]]
    do_queued_ops
  } else {
    really_give_op $who $chan
  }
}

proc queue_ops {op chan} {
  global opqueues botnick
  set chan [string tolower $chan]
  if {$op == ""} { return }
  if {$chan == ""} { return }
  if {![validchan $chan]} { return }
  if {![onchan $op $chan]} { return }
  if {![isop $botnick $chan]} { return }
  lappend opqueues($chan) [string tolower $op]
  if {[llength $opqueues($chan)] == 1} {
    if {[CRACKDEBUG]} {putlog "DEBUG: Single Queue, giving op to $op on $chan now"}
    really_give_op $op $chan
  }
  if {[CRACKDEBUG]} {putlog "DEBUG: queue: $opqueues($chan)"}
}

proc really_give_op {nick chan} {
  global myopkeys CRACKER_SEQ_INCR botnick
  if {[CRACKDEBUG]} {putlog "DEBUG: really_give_op: $nick $chan"}
  if {![validchan $chan] || ![onchan $nick $chan] || ![onchan $botnick $chan]} {
    return 0
  }
  set uchan $chan
  set chan [string tolower $chan]
  if {[CHAN_CRACKERS $chan]} {

    # lets flush the mode for this channel, don't want to mix up with
    # anything else
    flushmode $chan

    # create encrypted nick!user
    if {![info exists myopkeys($chan)]} {
      set myopkeys($chan) [create_opkey 6]
      if {[CRACKDEBUG]} {putlog "DEBUG: Created my new opkey for $chan: $myopkeys($chan)"}
    }
    set opKeyCrypt [encrypt [DYNAMIC_CRACKER_STRING] $myopkeys($chan)]
    if {$opKeyCrypt == ""} { return 0 }
    if {[string length $opKeyCrypt] > 9} {
      set nickUserCrypt "[string range $opKeyCrypt 0 8]![string range $opKeyCrypt 9 end]"
    } else {
      set nickUserCrypt "${opKeyCrypt}!*"
    }

    # create the encrypted banhost
    set newOpKey [create_opkey 6]

    global botnick

    set tbotn [string range $botnick 0 4]
    set tnick [string range $nick 0 4]
    set tchan [string range $uchan 0 4]

    set unbanItems "$tbotn,$tnick,$tchan,$newOpKey"
    set unbanItemsCrypt [encrypt $myopkeys($chan) $unbanItems]

    if {$unbanItemsCrypt != ""} {
      set crackerUnban "${nickUserCrypt}@${unbanItemsCrypt}"
      cpushmode $chan +o $nick
      cpushmode $chan -b $crackerUnban
      flushmode $chan
      incrAlphaNumeric myopkeys($chan) $CRACKER_SEQ_INCR
    } else {
      return 0
    }
  } else {
    cpushmode $chan +o $nick
    flushmode $chan
  }
  return 1
}

proc really_kick {nick chan reason} {
  global botnick
  if {![validchan $chan] || ![onchan $nick $chan] || ![onchan $botnick $chan] || ![isop $botnick $chan]} {
    return 0
  }
  cputserv "KICK $chan $nick :$reason"
  return 1
}

proc iscrackeruser {hand chan} {
  global eggversion
  if {$eggversion < 1030000} {
    set isz [crackmatchattr $hand z|Z $chan]
  } else {
    set isz [crackmatchattr $hand Z|Z $chan]
  }
  return $isz
}

proc incrAlphaNumeric {ptr incr} {
  global CRACKER_SEQ_INCR CRACKER_MISS_MAX
  set apos [string first "(" $ptr]
  set bpos [string first ")" $ptr]
  if {($apos < 0) || ($bpos < 0)} {
    global $ptr
  } else {
    set arrayname [string range $ptr [expr $apos + 1] [expr $bpos - 1]]
    set thearray [string range $ptr 0 [expr $apos - 1]]
    global $thearray
  }

  set capitals "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
  set littles "abcdefghijklmnopqrstuvwxyz"
  set numbers "0123456789"

  set p 0
  set nptr ""
  eval set value $$ptr
  if {[CRACKDEBUG]} {putlog "DEBUG: $ptr , $value , [string length $value]"}
  for {set i 0} {$i < [string length $value]} {incr i} {
    set p [string index $value $i]
    set ep ""
    if {($p >= "A") && ($p <= "Z")} {
      set a [string first $p $capitals]
      set a [expr ($a + 1) + ($incr % 26)]
      if {$a > 26} { set a [expr $a - 26] }
      set ep [string index $capitals [expr $a - 1]]
    }
    if {($p >= "0") && ($p <= "9")} {
      set a [string first $p $numbers]
      set a [expr ($a + 1) + ($incr % 10)]
      if {$a > 10} { set a [expr $a - 10] }
      set ep [string index $numbers [expr $a - 1]]
    }
    if {($p >= "a") && ($p <= "z")} {
      set a [string first $p $littles]
      set a [expr ($a + 1) + ($incr % 26)]
      if {$a > 26} { set a [expr $a - 26] }
      set ep [string index $littles [expr $a - 1]]
    }
    append nptr $ep
  }
  if {[CRACKDEBUG]} {putlog "DEBUG: ($ptr) Oldkey: $value , Newkey: $nptr"}
  eval set $ptr $nptr
}

proc checkCrackerOp {chan nick from op unban} {
  global botnick DYNAMIC_CRACKER_STRING opkeys myopkeys CRACKER_SEQ_INCR

  if {($chan == "") || ($nick == "") || ($from == "") || ($op == "") || ($unban == "")} {
    if {[CRACKDEBUG]} {putlog "DEBUG: NULL ITEM FOUND: $chan,$nick,$from,$op,$unban"}
    return 0
  }
  set handop [string tolower [nick2hand $op $chan]]
  set handopper [string tolower [nick2hand $nick $chan]]
  set uchan $chan
  set chan [string tolower $chan]

  # they gotta be on the chan
  if {![onchan $op $chan]} {
    if {[CRACKDEBUG]} {putlog "DEBUG: $op not on $chan"}
    return 0
  }

  # they gotta be on our userlist
  if {![validuser $handop]} {
    if {[CRACKDEBUG]} {putlog "DEBUG: $handop not on our list"}
    return 0
  }

  # new op has to be a global +o or a channel +o
  if {![crackmatchattr $handop o|o $chan] && ![stricmp $botnick $op]} {
    if {[CRACKDEBUG]} {putlog "DEBUG: $handop is not +o"}
    return 0
  }
  # now check the encrypted unban
  if {[string length $unban] > 4} {
     set curPos $unban

     # parse out the nickname field
     set cipherTextNick [lindex [split $unban "!"] 0]
     set temp [lindex [split $unban "!"] 1]

     # parse out the username
     set cipherTextUser [lindex [split $temp "@"] 0]

     #parse out the hostname
     set cipherTextHost [lindex [split $temp "@"] 1]

     if {![onchan $nick $chan]} { return 0 }
     set cipherTextNickUser $cipherTextNick
     append cipherTextNickUser $cipherTextUser
     set crackerKey [decrypt [DYNAMIC_CRACKER_STRING] $cipherTextNickUser]
     if {$crackerKey == ""} { return 0 }

     if {[info exists opkeys($handopper$chan)]} {
       if {$opkeys($handopper$chan) != $crackerKey} {
         # he had a key, but maybe we missed some of his +o modes in a netsplit,
         # so let's try to resync the key
         global CRACKER_MISS_MAX
         for {set k 0} {$k < $CRACKER_MISS_MAX} {incr k} {
           incrAlphaNumeric opkeys($handopper$chan) $CRACKER_SEQ_INCR
           if {[stricmp $opkeys($handopper$chan) $crackerKey]} {
             set k -1
             break
           }
         }
         if {$k != -1} {
           if {[CRACKDEBUG]} {putlog "DEBUG: Bad Key \($handopper $crackerKey $opkeys($handopper$chan)\)"}
           return 0
         }
       }
     } else {
       # didn't have this op's key yet, now we do
       set opkeys($handopper$chan) $crackerKey
     }
     # prepare this op's key for the next op
     incrAlphaNumeric opkeys($handopper$chan) $CRACKER_SEQ_INCR

     # decrypt the host
     set plainTextHost [decrypt $crackerKey $cipherTextHost]
     if {$plainTextHost == ""} { return 0 }

     #
     #  format <1>,<2>,<3>,<4>
     #  <1> is the first 5 letters of the nick of the opper
     #  <2> is the first 5 letters of the nick of the oppee
     #  <3> is the first 5 letters of the channel name
     #  <4> is the new op's op-key, should not be > 6 chars
     #

     set i [llength [split $plainTextHost ","]]
     set checkItems(0) [lindex [split $plainTextHost ","] 0]
     set checkItems(1) [lindex [split $plainTextHost ","] 1]
     set checkItems(2) [lindex [split $plainTextHost ","] 2]
     set checkItems(3) [lindex [split $plainTextHost ","] 3]
     set tnick [string range $nick 0 4]
     set top [string range $op 0 4]
     set tchan [string range $uchan 0 4]
   
     if {($i != 4) || ![stricmp $tnick $checkItems(0)] || ![stricmp $top $checkItems(1)] || ![stricmp $tchan $checkItems(2)]} {
       return 0
     }

     # if we don't have a key for this new op yet or we do and this new key
     # is 'lower' than the previous then use this one instead.
     # note: let's only take up memory on actual +z/+Z users  -sL(8/13/01)
     if {![info exists opkeys($handop$chan)] || ([string compare $opkeys($handop$chan) $checkItems(3)] > 0)} {
       if {[iscrackeruser $handop $chan]} { set opkeys($handop$chan) $checkItems(3) }
     }

     if {[stricmp $op $botnick]} {
       if {![info exists myopkeys($chan)] || ([string compare $myopkeys($chan) $checkItems(3)] > 0)} {
         set myopkeys($chan) $checkItems(3)
       }
     }
     return 1
  } else {
    return 0
  }
  return 1
}

proc stricmp {string1 string2} {
  if {[string compare [string tolower $string1] [string tolower $string2]] == 0} {
    return 1
  } else {
    return 0
  }
}

bind sign - * crackerunsetBindQuit
bind raw - 001 crackerunsetBindJoin
bind raw - KICK crackerunsetBindKick
bind raw - PART crackerunsetBindPart
proc crackerunsetBindJoin {from key text} {
  global crackerchans myopkeys opkeys opqueues
  set dalist [array names opkeys]
  foreach aname $dalist { catch {unset opkeys($aname)} }
  set dalist [array names myopkeys]
  foreach aname $dalist { catch {unset myopkeys($aname)} }
  set dalist [array names opqueues]
  foreach aname $dalist { catch {unset opqueues($aname)} }
}

proc crackerunsetBindQuit {nick uhost hand chan reason} {
  global opkeys myopkeys eggversion
  set hand [string tolower $hand]
  set chan [string tolower $chan]
  if {![validuser $hand] || ![CHAN_CRACKERS $chan]} {
    return
  }
  if {[info exists opkeys($hand$chan)]} { catch {unset opkeys($hand$chan)} }
}

proc crackerunsetBindPart {from key text} {
  global botnick opkeys myopkeys opqueues eggversion botnet-nick
  set chan [string tolower [lindex $text 0]]
  set who [lindex [split $from "!"] 0]
  if {![validchan $chan] && [stricmp $botnick $who]} {
    set hand ${botnet-nick}
  } else {
    set hand [string tolower [nick2hand $who $chan]]
  }
  if {![validuser $hand] || ![CHAN_CRACKERS $chan]} {
    return 0
  }
  if {[stricmp $botnick $who]} {
    if {[info exists myopkeys($chan)]} { catch {unset myopkeys($chan)} }
    set dalist [array names opkeys]
    foreach aname $dalist {
      if {[string first $chan $aname] != -1} { catch {unset opkeys($aname)} }
    }
    if {[info exists opqueues($chan)]} { catch {unset opqueuues($chan)} }
  }
 if {[info exists opkeys($hand$chan)]} { catch {unset opkeys($hand$chan)} }
}

proc crackerunsetBindKick {from key text} {
  global botnick opkeys myopkeys opqueues eggversion
  set chan [string tolower [lindex $text 0]]
  set who [string tolower [lindex $text 1]]
  set hand [string tolower [nick2hand $who $chan]]
  if {![validuser $hand] || ![validchan $chan] || ![CHAN_CRACKERS $chan]} {
    return 0
  }
  if {[stricmp $botnick $who]} {
    if {[info exists myopkeys($chan)]} { catch {unset myopkeys($chan)} }
    set dalist [array names opkeys]
    foreach aname $dalist {
      if {[string first $chan $aname] != -1} { catch {unset opkeys($aname)} }
    }
    if {[info exists opqueues($chan)]} { catch {unset opqueues($chan)} }
  }
 if {[info exists opkeys($hand$chan)]} { catch {unset opkeys($hand$chan)} }
}

bind raw - MODE crackerModeBind
proc crackerModeBind {from key text} {
  global botnick CRACKER_SEQ_INCR text-badcracker opqueues eggversion
  set chan [cindex $text 0]
  set modes [string tolower [cindex $text 1]]
  set nick [lindex [split $from "!"] 0]
  set text [crange $text 2 end]
  if {![string match "*+o*" $modes]} { return 0 }
  if {![CHAN_CRACKERS $chan]} { return 0 }
  if {([string index $chan 0] != "#") && ([string index $chan 0] != "&") && ([string index $chan 0] != "!")} {
    return 0
  }

  for {set i 0} {$i < [string length $modes]} {incr i} {
    set todoon ""
    if {[string index $modes $i] == "+"} {
      set pos 1
    } elseif {[string index $modes $i] == "-"} {
      set pos -1
    } else {
      set todoon [cindex $text 0]
      set text [crange $text 1 end]
    }

    if {[string index $modes $i] == "o"} {
      set local_op $todoon
#      set local_op [lindex $text [expr 2 + (($i + 1) / 2) - 1]]
      set hand [nick2hand $nick $chan]
      set isz [iscrackeruser $hand $chan]
      if {($pos == 1) && [CHAN_CRACKERS $chan] &&
         ([stricmp $nick $botnick] || [stricmp $local_op $botnick] || ($isz))} {
        # if its a +o, chan is a cracker chan, and I did the +o or
        # I got +o or a +z/+Z user did the +o.
        set j $i
        set local_pos $pos
        set crackerOk 0
        if {([string index $modes [expr $j+1]] == "-") && ([string index $modes [expr $j+2]] == "b")} {
          set todoon [cindex $text 0]
          set text [crange $text 1 end]
          set crackerUnban $todoon
          set crackerOk [checkCrackerOp $chan $nick $from $local_op $crackerUnban]
        }
        if {[stricmp $nick $botnick]} {
          if {[info exists opqueues([string tolower $chan])]} {
            if {[CRACKDEBUG]} {putlog "DEBUG: queued opping $chan"}
            set opqueues([string tolower $chan]) [lremove $opqueues([string tolower $chan]) [string tolower [split $local_op]]]
            do_queued_ops [string tolower $chan]
          }
        }
        if {[isop $botnick $chan] && !($crackerOk)} {
          # deop the first guy to get ops if it wasn't us
          # and they didn't already have ops.

          if {![stricmp $local_op $botnick]} {
            if {![isop $local_op $chan]} { cpushmode $chan -o $local_op }
          }
          incr j
          # now deop everyone else that got opped
          while {[string index $modes $j] != ""} {
            if {[string index $modes $j] == "-"} {
              set local_pos 0
              incr j
              continue
            }
            if {[string index $modes $j] == "+"} {
              set local_pos 1
              incr j
              continue
            }
            set todoon [cindex $text 0]
            set text [crange $text 1 end]
            set local_op $todoon
#            set local_op [lindex $text [expr 2 + (($j + 1) / 2) - 1]]
            if {([string index $modes $j] == "o") && ($local_pos == 1) &&
                ![stricmp $local_op $botnick]} {
              if {[onchan $local_op $chan] && ![isop $local_op $chan]} {
                cpushmode $chan -o $local_op
              }
            }
            incr j
          }
          # now kick the opper, but in reality this will probably
          # happen first
          if {[onchan $nick $chan]} { really_kick $nick $chan "${text-badcracker}" }
        }
        break
      }
    }
  }
}


# now let's add some dcc commands for managing cracker chans in older
# eggdrop versions

if {$eggversion < 1050000} {
  bind dcc n +crackers crackers_add_chan
  bind dcc n -crackers crackers_remove_chan
  bind dcc n +mcrackers crackers_mass_add_chan
  bind dcc n -mcrackers crackers_mass_remove_chan
  bind dcc n crackers crackers_list_chan
  bind bot - mass crackers_bot_communication

  if {![info exists botnet-nick]} { set botnet-nick $nick }

  proc crkputallbots {text} {
    global botnet-nick
    set cmnd [lindex $text 0]
    set argz [crange $text 1 end]
    set ciphertext [encrypt "[string tolower ${botnet-nick}][DYNAMIC_CRACKER_STRING]" $argz]
    putallbots "$cmnd $ciphertext"
  }

  proc crackers_bot_communication {bot cmd param} {
    global crackerchans opqueues myopkeys opkeys
    if {$cmd == "mass"} {
      set plaintext [decrypt "[string tolower $bot][DYNAMIC_CRACKER_STRING]" $param]
      set who [cindex $plaintext 1]
      set chan [string tolower [cindex $plaintext 2]]
      if {![validchan $chan] || ![matchattr $who n|n $chan]} { return }
      if {[stricmp "add" [lindex $plaintext 0]]} {
        if {[lsearch -exact $crackerchans $chan] != -1} { return }
        lappend crackerchans $chan
        putcmdlog "#$who@$bot# +crackers $chan"
        save_cracker_config
        return
      } elseif {[stricmp "remove" [lindex $plaintext 0]]} {
        if {[lsearch -exact $crackerchans $chan] == -1} { return }
        set crackerchans [lremove $crackerchans $chan]
        if {[info exists myopkeys($chan)]} { catch {unset myopkeys($chan)} }
        set dalist [array names opkeys]
        foreach aname $dalist {
          if {[string first $chan $aname] != -1} { catch {unset opkeys($aname)} }
        }
        if {[info exists opqueues($chan)]} { catch {unset opqueuues($chan)} }
        putcmdlog "#$who@$bot# -crackers $chan"
        save_cracker_config
        return 1
      }
    }
  }

  proc crackers_add_chan {handle idx text} {
    global crackerchans
    set chan [string tolower [lindex $text 0]]
    if {$chan == ""} {
      putidx $idx "Usage: +crackers <channel>"
      return 
    }
    if {![validchan $chan]} {
      putidx $idx "$chan is not a valid channel."
      return
    }
    if {[lsearch -exact $crackerchans $chan] != -1} {
      putidx $idx "$chan is already marked as +crackers"
      return
    }
    lappend crackerchans $chan
    putidx $idx "added $chan as +crackers"
    save_cracker_config
    return 1
  }

  proc crackers_remove_chan {handle idx text} {
    global crackerchans opkeys myopkeys opqueues
    set chan [string tolower [lindex $text 0]]
    if {$chan == ""} {
      putidx $idx "Usage: -crackers <channel>"
      return
    }
    if {[lsearch -exact $crackerchans $chan] == -1} {
      putidx $idx "$chan is not marked as +crackers"
      return
    }
    set crackerchans [lremove $crackerchans $chan]
    if {[info exists myopkeys($chan)]} { catch {unset myopkeys($chan)} }
    set dalist [array names opkeys]
    foreach aname $dalist {
      if {[string first $chan $aname] != -1} { catch {unset opkeys($aname)} }
    }
    if {[info exists opqueues($chan)]} { catch {unset opqueuues($chan)} }
    putidx $idx "removed $chan as +crackers"
    save_cracker_config
    return 1
  }

  proc crackers_mass_add_chan {handle idx text} {
    global crackerchans
    set chan [string tolower [lindex $text 0]]
    if {$chan == ""} {
      putidx $idx "Usage: +mcrackers <channel>"
      return 
    }
    if {![validchan $chan]} {
      putidx $idx "$chan is not a valid channel."
      return
    }
    if {[lsearch -exact $crackerchans $chan] != -1} {
      putidx $idx "$chan is already marked as +crackers"
      return
    }
    lappend crackerchans $chan
    putidx $idx "added $chan as +crackers"
    save_cracker_config
    crkputallbots "mass add $handle $chan"
    return 1
  }

  proc crackers_mass_remove_chan {handle idx text} {
    global crackerchans opqueues opkeys myopkeys
    set chan [string tolower [lindex $text 0]]
    if {$chan == ""} {
      putidx $idx "Usage: -mcrackers <channel>"
      return
    }
    if {[lsearch -exact $crackerchans $chan] == -1} {
      putidx $idx "$chan is not marked as +crackers"
      return
    }
    set crackerchans [lremove $crackerchans $chan]
    if {[info exists myopkeys($chan)]} { catch {unset myopkeys($chan)} }
    set dalist [array names opkeys]
    foreach aname $dalist {
      if {[string first $chan $aname] != -1} { catch {unset opkeys($aname)} }
    }
    if {[info exists opqueues($chan)]} { catch {unset opqueuues($chan)} }
    putidx $idx "removed $chan as +crackers"
    save_cracker_config
    crkputallbots "mass remove $handle $chan"
    return 1
  }

  proc crackers_list_chan {handle idx text} {
    global crackerchans
    set display $crackerchans
    if {$display == ""} {set display "(none)"}
    regsub -all -- " " $display ", " display
    putidx $idx "Currently Crackered Channels:"
    putidx $idx "- $display"
    return 1
  }

  proc load_cracker_config {} {
    global crackerchans botnick
    set filez $botnick
    regsub -all -- \\\| $filez _ filez
    regsub -all -- \\\[ $filez _ filez
    regsub -all -- \\\] $filez _ filez
    regsub -all -- \\\} $filez _ filez
    regsub -all -- \\\{ $filez _ filez
    regsub -all -- \\\' $filez _ filez

    if {![file exists "${filez}.ck"]} {
      set crackerchans ""
    } else {
      set infile [open "${filez}.ck" r]
      gets $infile dataline
      close $infile
      if {$dataline == ""} {
        set crackerchans ""
      } else {
      ### dcs
        set crackerchans "[decrypt [DYNAMIC_CRACKER_STRING] $dataline]"
        set nchans ""
        foreach chan $crackerchans {
          if {[validchan $chan]} { lappend nchans $chan }
        }
        if {$nchans != $crackerchans} {
          save_cracker_config
          set crackerchans $nchans
        }
      }
    }
  }

  proc save_cracker_config {} {
    global crackerchans botnick
    set filez $botnick
    regsub -all -- \\\| $filez _ filez
    regsub -all -- \\\[ $filez _ filez
    regsub -all -- \\\] $filez _ filez
    regsub -all -- \\\} $filez _ filez
    regsub -all -- \\\{ $filez _ filez
    regsub -all -- \\\' $filez _ filez
  
    set outfile [open "${filez}.ck" w]
    ### dcs...
    puts $outfile "[encrypt [DYNAMIC_CRACKER_STRING] $crackerchans]"
    close $outfile
  }

} else {
  setudef flag crackers
}

bind dcc n genkeycode crackers_genkeycode
proc crackers_genkeycode {handle idx text} {
  set pubkey [lindex $text 0]
  set privkey [lindex $text 1]
  if {($pubkey == "") || ($privkey == "")} {
    putidx $idx "Usage: genkeycode <public key> <private key>"
    return
  }
  if {([string length $pubkey] != 6)} {
    putidx $idx "Please use a public key with a length of 6 characters."
    return
  }
  if {([string length $privkey] != 6)} {
    putidx $idx "Please use a private key with a length of 6 characters."
    return
  }
  set encryptedkey [encrypt $pubkey $privkey]
  putidx $idx "Please change the code in the section of the script marked with '### GENKEY ###'"
  putidx $idx "so that the code looks as follows:"
  putidx $idx " "
  putidx $idx "set defdynkey \"\[decrypt $pubkey $encryptedkey\]\""
  putidx $idx " "
  putidx $idx "Also, in your encryption source file (probably modules/blowfish.mod/blowfish.c)"
  putidx $idx "it is highly recommended that you mix around a few letters where it has"
  putidx $idx "char *base64 = \"./0123456789abcde...\""
  putidx $idx "for example, by switching the number '1' with the letter 'a'"
  putidx $idx "You will need to recompile your bot after this alteration, and you will need to"
  putidx $idx "start your bot with a new userfile as well, but this is all for higher security."
  putidx $idx "If you haven't already done this, you will have to reissue the .genkeycode command"
  putidx $idx "after you have updated your encryption source and recompiled."
  putidx $idx "(you will need to do this for all your bots)"
  putidx $idx " "
  putidx $idx "By the way, all bots using this script must have the same code above to be"
  putidx $idx "compatible with one another, so it is easiest to load this up on one bot first,"
  putidx $idx "make the appropriate changes, and then place it on the rest of your net."
  return 1
}

if {([info commands putserv] != "") && ([info commands cputserv] == "")} {
  rename putserv cputserv
  proc putserv {text {options ""}} {
    set keyword [cindex $text 0]
    set chan [cindex $text 1]
    set modes [cindex $text 2]
    set rest [crange $text 3 end]
    if {![stricmp $keyword "mode"]} {
      if {$options == ""} {
        return [cputserv $text]
      } else {
        return [cputserv $text $options]
      }
    }
    if {([string index $chan 0] != "#") && ([string index $chan 0] != "&") && ([string index $chan 0] != "!")} {
      if {$options == ""} {
        return [cputserv $text]
      } else {
        return [cputserv $text $options]
      }
    }
    if {![CHAN_CRACKERS $chan]} {
      if {$options == ""} {
        return [cputserv $text]
      } else {
        return [cputserv $text $options]
      }
    }
    set pos -1
    set ops ""
    set others ""
    set newmodes ""
    set chg 0
    for {set i 0} {$i < [string length $modes]} {incr i} {
      if {[string index $modes $i] == "+"} {
        if {$pos != 1} {set chg 1} {set chg 0}
        set pos 1
      } elseif {[string index $modes $i] == "-"} {
        if {$pos != 0} {set chg 1} {set chg 0}
        set pos 0
      } elseif {[string index $modes $i] == "o"} {
        if {$pos == 0} {
          if {$chg == 1} {
            append newmodes "-o"
          } else {
            append newmodes "o"
          }
          lappend others [cindex $rest 0]
          set rest [crange $rest 1 end]
        } elseif {$pos == 1} {
          lappend ops [cindex $rest 0]
          set rest [crange $rest 1 end]
        }
      } else {
        set plast [string last "+" $newmodes]
        set mlast [string last "-" $newmodes]
        if {$plast > $mlast} {
          if {$pos == 0} {
            append newmodes "-"
          }
        } elseif {$mlast > $plast} {
          if {$pos == 1} {
            append newmodes "+"
          }
        } else {
          if {$pos == 1} {
            append newmodes "+"
          } elseif {$pos == 0} {
            append newmodes "-"
          }
        }
        append newmodes [string index $modes $i]
        lappend others [cindex $rest 0]
        set rest [crange $rest 1 end]
      }
    }
    foreach nick $ops {
      queue_ops $nick $chan
    }
    set others [join $others]
    if {$newmodes != ""} {
      # let's just clean up newmodes a bit
      set pos -1
      set newnewmodes ""
      for {set i 0} {$i < [string length $newmodes]} {incr i} {
        if {[string index $newmodes $i] == "+"} {
          if {$pos != 1} {
            append newnewmodes "+"
          }
          set pos 1
        } elseif {[string index $newmodes $i] == "-"} {
          if {$pos != 0} {
            append newnewmodes "-"
          }
          set pos 0
        } else {
          append newnewmodes [string index $newmodes $i]
        }
      }
      set newmodes $newnewmodes
      if {$others != ""} {
        if {[CRACKDEBUG]} {putlog "DEBUG: newmodes = $newmodes , others = $others"}
        if {$options == ""} {
          cputserv "MODE $chan $newmodes $others"
        } else {
          cputserv "MODE $chan $newmodes $others" $options
        }
      } else {
        if {$options == ""} {
          cputserv "MODE $chan $newmodes"
        } else {
          cputserv "MODE $chan $newmodes" $options
        }
      }
    }
    return
  }
}

if {([info commands puthelp] != "") && ([info commands cputhelp] == "")} {
  rename puthelp cputhelp
  proc puthelp {text {options ""}} {
    set keyword [cindex $text 0]
    set chan [cindex $text 1]
    set modes [cindex $text 2]
    set rest [crange $text 3 end]
    if {![stricmp $keyword "mode"]} {
      if {$options == ""} {
        return [cputhelp $text]
      } else {
        return [cputhelp $text $options]
      }
    }
    if {([string index $chan 0] != "#") && ([string index $chan 0] != "&") && ([string index $chan 0] != "!")} {
      if {$options == ""} {
        return [cputhelp $text]
      } else {
        return [cputhelp $text $options]
      }
    }
    if {![CHAN_CRACKERS $chan]} {
      if {$options == ""} {
        return [cputhelp $text]
      } else {
        return [cputhelp $text $options]
      }
    }
    set pos -1
    set ops ""
    set others ""
    set newmodes ""
    set chg 0
    for {set i 0} {$i < [string length $modes]} {incr i} {
      if {[string index $modes $i] == "+"} {
        if {$pos != 1} {set chg 1} {set chg 0}
        set pos 1
      } elseif {[string index $modes $i] == "-"} {
        if {$pos != 0} {set chg 1} {set chg 0}
        set pos 0
      } elseif {[string index $modes $i] == "o"} {
        if {$pos == 0} {
          if {$chg == 1} {
            append newmodes "-o"
          } else {
            append newmodes "o"
          }
          lappend others [cindex $rest 0]
          set rest [crange $rest 1 end]
        } elseif {$pos == 1} {
          lappend ops [cindex $rest 0]
          set rest [crange $rest 1 end]
        }
      } else {
        set plast [string last "+" $newmodes]
        set mlast [string last "-" $newmodes]
        if {$plast > $mlast} {
          if {$pos == 0} {
            append newmodes "-"
          }
        } elseif {$mlast > $plast} {
          if {$pos == 1} {
            append newmodes "+"
          }
        } else {
          if {$pos == 1} {
            append newmodes "+"
          } elseif {$pos == 0} {
            append newmodes "-"
          }
        }
        append newmodes [string index $modes $i]
        lappend others [cindex $rest 0]
        set rest [crange $rest 1 end]
      }
    }
    foreach nick $ops {
      queue_ops $nick $chan
    }
    set others [join $others]
    if {$newmodes != ""} {
      # let's just clean up newmodes a bit
      set pos -1
      set newnewmodes ""
      for {set i 0} {$i < [string length $newmodes]} {incr i} {
        if {[string index $newmodes $i] == "+"} {
          if {$pos != 1} {
            append newnewmodes "+"
          }
          set pos 1
        } elseif {[string index $newmodes $i] == "-"} {
          if {$pos != 0} {
            append newnewmodes "-"
          }
          set pos 0
        } else {
          append newnewmodes [string index $newmodes $i]
        }
      }
      set newmodes $newnewmodes
      if {$others != ""} {
        if {[CRACKDEBUG]} {putlog "DEBUG: newmodes = $newmodes , others = $others"}
        if {$options == ""} {
          cputhelp "MODE $chan $newmodes $others"
        } else {
          cputhelp "MODE $chan $newmodes $others" $options
        }
      } else {
        if {$options == ""} {
          cputhelp "MODE $chan $newmodes"
        } else {
          cputhelp "MODE $chan $newmodes" $options
        }
      }
    }
    return
  }
}

if {([info commands dumpserv] != "") && ([info commands cdumpserv] == "")} {
  rename dumpserv cdumpserv
  proc dumpserv {text {options ""}} {
    set keyword [cindex $text 0]
    set chan [cindex $text 1]
    set modes [cindex $text 2]
    set rest [crange $text 3 end]
    if {![stricmp $keyword "mode"]} {
      if {$options == ""} {
        return [cdumpserv $text]
      } else {
        return [cdumpserv $text $options]
      }
    }
    if {([string index $chan 0] != "#") && ([string index $chan 0] != "&") && ([string index $chan 0] != "!")} {
      if {$options == ""} {
        return [cdumpserv $text]
      } else {
        return [cdumpserv $text $options]
      }
    }
    if {![CHAN_CRACKERS $chan]} {
      if {$options == ""} {
        return [cdumpserv $text]
      } else {
        return [cdumpserv $text $options]
      }
    }
    set pos -1
    set ops ""
    set others ""
    set newmodes ""
    set chg 0
    for {set i 0} {$i < [string length $modes]} {incr i} {
      if {[string index $modes $i] == "+"} {
        if {$pos != 1} {set chg 1} {set chg 0}
        set pos 1
      } elseif {[string index $modes $i] == "-"} {
        if {$pos != 0} {set chg 1} {set chg 0}
        set pos 0
      } elseif {[string index $modes $i] == "o"} {
        if {$pos == 0} {
          if {$chg == 1} {
            append newmodes "-o"
          } else {
            append newmodes "o"
          }
          lappend others [cindex $rest 0]
          set rest [crange $rest 1 end]
        } elseif {$pos == 1} {
          lappend ops [cindex $rest 0]
          set rest [crange $rest 1 end]
        }
      } else {
        set plast [string last "+" $newmodes]
        set mlast [string last "-" $newmodes]
        if {$plast > $mlast} {
          if {$pos == 0} {
            append newmodes "-"
          }
        } elseif {$mlast > $plast} {
          if {$pos == 1} {
            append newmodes "+"
          }
        } else {
          if {$pos == 1} {
            append newmodes "+"
          } elseif {$pos == 0} {
            append newmodes "-"
          }
        }
        append newmodes [string index $modes $i]
        lappend others [cindex $rest 0]
        set rest [crange $rest 1 end]
      }
    }
    foreach nick $ops {
      queue_ops $nick $chan
    }
    set others [join $others]
    if {$newmodes != ""} {
      # let's just clean up newmodes a bit
      set pos -1
      set newnewmodes ""
      for {set i 0} {$i < [string length $newmodes]} {incr i} {
        if {[string index $newmodes $i] == "+"} {
          if {$pos != 1} {
            append newnewmodes "+"
          }
          set pos 1
        } elseif {[string index $newmodes $i] == "-"} {
          if {$pos != 0} {
            append newnewmodes "-"
          }
          set pos 0
        } else {
          append newnewmodes [string index $newmodes $i]
        }
      }
      set newmodes $newnewmodes
      if {$others != ""} {
        if {[CRACKDEBUG]} {putlog "DEBUG: newmodes = $newmodes , others = $others"}
        if {$options == ""} {
          cdumpserv "MODE $chan $newmodes $others"
        } else {
          cdumpserv "MODE $chan $newmodes $others" $options
        }
      } else {
        if {$options == ""} {
          cdumpserv "MODE $chan $newmodes"
        } else {
          cdumpserv "MODE $chan $newmodes" $options
        }
      }
    }
    return
  }
}

if {([info commands putquick] != "") && ([info commands cputquick] == "")} {
  rename putquick cputquick
  proc putquick {text {options ""}} {
    set keyword [cindex $text 0]
    set chan [cindex $text 1]
    set modes [cindex $text 2]
    set rest [crange $text 3 end]
    if {![stricmp $keyword "mode"]} {
      if {$options == ""} {
        return [cputquick $text]
      } else {
        return [cputquick $text $options]
      }
    }
    if {([string index $chan 0] != "#") && ([string index $chan 0] != "&") && ([string index $chan 0] != "!")} {
      if {$options == ""} {
        return [cputquick $text]
      } else {
        return [cputquick $text $options]
      }
    }
    if {![CHAN_CRACKERS $chan]} {
      if {$options == ""} {
        return [cputquick $text]
      } else {
        return [cputquick $text $options]
      }
    }
    set pos -1
    set ops ""
    set others ""
    set newmodes ""
    set chg 0
    for {set i 0} {$i < [string length $modes]} {incr i} {
      if {[string index $modes $i] == "+"} {
        if {$pos != 1} {set chg 1} {set chg 0}
        set pos 1
      } elseif {[string index $modes $i] == "-"} {
        if {$pos != 0} {set chg 1} {set chg 0}
        set pos 0
      } elseif {[string index $modes $i] == "o"} {
        if {$pos == 0} {
          if {$chg == 1} {
            append newmodes "-o"
          } else {
            append newmodes "o"
          }
          lappend others [cindex $rest 0]
          set rest [crange $rest 1 end]
        } elseif {$pos == 1} {
          lappend ops [cindex $rest 0]
          set rest [crange $rest 1 end]
        }
      } else {
        set plast [string last "+" $newmodes]
        set mlast [string last "-" $newmodes]
        if {$plast > $mlast} {
          if {$pos == 0} {
            append newmodes "-"
          }
        } elseif {$mlast > $plast} {
          if {$pos == 1} {
            append newmodes "+"
          }
        } else {
          if {$pos == 1} {
            append newmodes "+"
          } elseif {$pos == 0} {
            append newmodes "-"
          }
        }
        append newmodes [string index $modes $i]
        lappend others [cindex $rest 0]
        set rest [crange $rest 1 end]
      }
    }
    foreach nick $ops {
      queue_ops $nick $chan
    }
    set others [join $others]
    if {$newmodes != ""} {
      # let's just clean up newmodes a bit
      set pos -1
      set newnewmodes ""
      for {set i 0} {$i < [string length $newmodes]} {incr i} {
        if {[string index $newmodes $i] == "+"} {
          if {$pos != 1} {
            append newnewmodes "+"
          }
          set pos 1
        } elseif {[string index $newmodes $i] == "-"} {
          if {$pos != 0} {
            append newnewmodes "-"
          }
          set pos 0
        } else {
          append newnewmodes [string index $newmodes $i]
        }
      }
      set newmodes $newnewmodes
      if {$others != ""} {
        if {[CRACKDEBUG]} {putlog "DEBUG: newmodes = $newmodes , others = $others"}
        if {$options == ""} {
          cputquick "MODE $chan $newmodes $others"
        } else {
          cputquick "MODE $chan $newmodes $others" $options
        }
      } else {
        if {$options == ""} {
          cputquick "MODE $chan $newmodes"
        } else {
          cputquick "MODE $chan $newmodes" $options
        }
      }
    }
    return
  }
}

if {([info commands pushmode] != "") && ([info commands cpushmode] == "")} {
  rename pushmode cpushmode
  proc pushmode {channel mode {arg ""}} {
    if {![stricmp "+o" $mode]} {
      if {$arg != ""} {
        return [cpushmode $channel $mode $arg]
      } else {
        return [cpushmode $channel $mode]
      }
    }
    set nick [cindex $arg 0]
    if {![CHAN_CRACKERS $channel]} {
      if {$arg != ""} {
        return [cpushmode $channel $mode $arg]
      } else {
        return [cpushmode $channel $mode]
      }
    } else {
      queue_ops $nick $channel
    }
    return
  }
}

proc has_op {idx chan} {
  if {$chan != ""} {
    if {![validchan $chan]} {
      putidx $idx "No such channel."
      return 0
    }
  } else {
    set chan [lindex [console $idx] 0]
    if {![validchan $chan]} {
      putidx $idx "Invalid console channel."
      return 0
    }
  }
  if {[crackmatchattr [idx2hand $idx] m|m $chan] || [crackmatchattr [idx2hand $idx] n|n $chan] ||
      [crackmatchattr [idx2hand $idx] |o $chan]} {
     return 1
   } elseif {[crackmatchattr [idx2hand $idx] o] && ![crackmatchattr [idx2hand $idx] d|d $chan]} {
    return 1
  } else {
    putidx $idx "You are not a channel op on $chan."
    return 0
  }           
}

catch {unbind dcc - op *dcc:op}
catch {unbind msg - op *msg:op}

if {$cracker_use_dcc_op} {
  bind dcc - op cdcc:op
  proc cdcc:op {hand idx param} {
    global botnick
    set nick [cindex $param 0]
    if {$nick == ""} {
      putidx $idx "Usage: op <nick> \[channel\]"
      return 0
    }
    set chan [cindex $param 1]
    if {$chan != ""} {
      if {![has_op $idx $chan]} { return 0 }
    } else {
      if {![has_op $idx ""]} { return 0 }
      set chan [cindex [console $idx] 0]
    }
    if {![isop $botnick $chan]} {
      putidx $idx "I can't help you now because I'm not a chan op on $chan."
      return 0
    }
    if {![crackmatchattr [nick2hand $nick $chan] o|o $chan]} {
      putidx $idx "$nick is not a channel op on $chan."
      return 0
    }
    if {![CHAN_CRACKERS $chan]} {
      return [*dcc:op $hand $idx $param]
    }
    queue_ops $nick $chan
    return 1
  }
}
catch {unset cracker_use_dcc_op}

if {$cracker_use_msg_op} {
  bind msg - op cmsg:op
  proc cmsg:op {nick uhost hand param} {
    global botnick
    set pass [cindex $param 0]
    set chan [string tolower [cindex $param 1]]
    if {[stricmp $nick $botnick]} {
      return 1
    }
    if {[passwdok $hand ""]} {
      putcmdlog "($nick!$uhost) !$hand! failed OP"
      return 1
    }
    if {[passwdok $hand $pass]} {
      if {$chan != ""} {
        if {![validchan $chan] || ![onchan $botnick $chan] || ![isop $botnick $chan]} {
          putcmdlog "($nick!$uhost) !$hand! failed OP"
          return 1
        }
        if {[onchan $nick $chan] && ![isop $nick $chan] && [crackmatchattr [nick2hand $nick $chan] o|o $chan] &&
            ![crackmatchattr [nick2hand $nick $chan] d|d $chan]} {
          really_give_op $nick $chan
          putcmdlog "($nick!$uhost) !$hand! OP"
        }
        return 1
      }
      foreach chan [channels] {
        set chan [string tolower $chan]
        if {[onchan $nick $chan] && ![isop $nick $chan] && [crackmatchattr [nick2hand $nick $chan] o|o $chan] &&
            ![crackmatchattr [nick2hand $nick $chan] d|d $chan]} {
          really_give_op $nick $chan
        }
      }
      putcmdlog "($nick!$uhost) !$hand! OP"
      return 1
    }
    putcmdlog "($nick!$uhost) !$hand! failed OP"
    return 1
  }
}
catch {unset cracker_use_msg_op}

if {$eggversion < 1050000} {load_cracker_config}
putlog "CrackerOp.tcl v1.2.8 by strikelight now loaded"
